<?php if (!defined('PmWiki')) exit();
/**
 * set_args_map.php
 * @author V.Krishn (vkrishn@ainsteps.net), Copyright 2009
 * @note This file is part of Cookbook recipe "Jscm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package jscm
 */

// *******************************************************
SDV($Jscm['default']['menu']['id'], 'cmMainID');
SDV($Jscm['default']['menu']['name'], 'cmMainMenu');
SDV($Jscm['default']['menu']['orient'], 'hbr');
SDV($Jscm['default']['menu']['theme'], 'cmThemeNB');
SDV($Jscm['default']['menu']['themedir'], 'ThemeNB');
SDV($Jscm['default']['menu']['themebase'], $Jscm['default']['menu']['theme'].'Base');
// *******************************************************
$cmID = $Jscm['default']['menu']['id'];
$cmMenu = $Jscm['default']['menu']['name'];
$cmOrient = $Jscm['default']['menu']['orient'];
$cmTheme = $Jscm['default']['menu']['theme'];
$cmThemeDir = $Jscm['default']['menu']['themedir'];
$cmThemeBase = $Jscm['default']['menu']['themebase'];
// *******************************************************
global $cmDrawParam, $cmDrawFromTextParam,
       $cmDrawDefault,
       $cmOrients, $cmThemes;
// cmDraw (cmID, cmMenu, cmOrient, nodeProperties, prefix); //see jscookmenu.js
$cmDrawParam = array('cmID', 'cmMenu', 'cmOrient', 'cmTheme', 'cmThemeDir', 'cmThemeBase');
//$cmDrawParam = array('cmID', 'cmMenu', 'cmOrient', 'cmTheme');
// cmDrawFromText ('cmID', 'cmOrient', cmTheme, 'cmThemeDir'); //see jscookmenu.js
$cmDrawFromTextParam = array('cmID', 'cmOrient', 'cmTheme', 'cmThemeDir', 'cmThemeBase');
//$cmDrawFromTextParam = array('cmID', 'cmOrient', 'cmTheme');

$cmDrawDefault = compact($cmDrawParam);
SDVA($cmOrients, array('hbr', 'hbl', 'hur', 'hul', 'vbr', 'vbl', 'vur', 'vul'));
SDVA($cmThemes, array(
 'cmThemeMiniBlack' => 'ThemeMiniBlack',
 'cmThemePanel' => 'ThemePanel',
 'cmThemeIE' => 'ThemeIE',
 'cmThemeOffice' => 'ThemeOffice',
 'cmThemeOffice2003' => 'ThemeOffice2003',
 'cmThemeNB' => 'ThemeNB',
 'cmThemeMini' => 'ThemeMini',
 'cmThemeInfoClick' => 'ThemeInfoClick'
));
// *******************************************************

function jscm_get_drawmap($params) {
  global $Jscm,
         $cmDrawParam, $cmDrawFromTextParam,
         $cmDrawDefault, $cmOrients, $cmThemes,
         $EnableJscmDebug;
  $args = ParseArgs($params);
  $count = count($args[""]);
  if($EnableJscmDebug > 0) { //debug
      //$Jscm['debug']['msg']['parseArgs'][] = $args;
  }
  $cmDrawValue = array();

  if ($count == '4') { //number of items in params
    foreach ($args[""] as $k => $v) { $cmDrawValue[$cmDrawParam[$k]] = $v; }
    foreach ($cmDrawValue as $k => $v) { $$k = $v; }
  }
  if ($count == '3') { //number of items in params
    foreach ($args[""] as $k => $v) { $cmDrawValue[$cmDrawFromTextParam[$k]] = $v; }
    foreach ($cmDrawValue as $k => $v) { $$k = $v; }
  }
  if($EnableJscmDebug > 0) { //debug
    //$Jscm['debug']['msg']['cmDrawValue'][] = $cmDrawValue;
  }

  if (!preg_match('/^[[:alnum:]]+$/', $cmID)) {
     $cmID = $cmDrawDefault['cmID'];
  }
  if (!preg_match('/^[[:alpha:]]+$/', $cmMenu)) {
     $cmMenu = $cmDrawDefault['cmMenu'];
  }
  $cmOrient = (in_array($cmDrawValue['cmOrient'], $cmOrients)) ?
           $cmDrawValue['cmOrient'] : $cmDrawDefault['cmOrient'];
  foreach ($cmThemes as $k => $v) {
    if ($cmDrawValue['cmTheme'] == $k) {
      $cmTheme = $k; $cmThemeDir = $v; break;
    } else {
      $cmTheme = $cmDrawDefault['cmTheme'];
      $cmThemeDir = $cmDrawDefault['cmThemeDir'];
    }
  }
  $cmThemeBase = $cmTheme.'Base';

  $cmDrawMap = compact($cmDrawParam);
  return $cmDrawMap;

}

//echo '<pre>'; print_r($params); echo '</pre>'; exit;

